image: node:18

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - node_modules/

stages:
  - install
  - test
  - build
  - deploy

install:
  stage: install
  script:
    - npm config set @pickyfi:registry=https://${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/
    - npm config set -- //${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=${CI_JOB_TOKEN}
    - npm ci

test:
  stage: test
  script:
    - npm t

build:
  stage: build
  script:
    - npm run build

deploy:
  stage: deploy
  rules:
    - if: '$CI_COMMIT_REF_NAME == "main"'
  script:
    - npm config set @pickyfi:registry=https://${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/
    - npm config set -- //${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=${CI_JOB_TOKEN}
    - npm install --only=dev
    - npx semantic-release
